package com.its.op.service.its.atrd;

import com.its.op.dao.repository.its.atrd.TbAtrdRepository;
import com.its.op.dto.its.atrd.TbAtrdDto;
import com.its.op.dto.its.atrd.TbAtrdRltnRoadDto;
import com.its.op.dto.its.common.UsageCountDto;
import com.its.op.entity.its.atrd.TbAtrd;
import com.its.op.entity.its.atrd.TbAtrdRltnRoad;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbAtrdService {

    private final TbAtrdRepository repo;
    private final TbAtrdRoadRltnService roadRltnService;

    // 데이터 1건 조회, 없으면 exception
    private TbAtrd requireOne(String id) throws NoSuchElementException {
        Optional<TbAtrd> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbAtrdDto> findAll() {
        List<TbAtrdDto> result = new ArrayList<>();
        List<TbAtrd> data = this.repo.findAll();
        for (TbAtrd entity : data) {
            result.add(entity.toDto(new ArrayList<>()));
        }
        return result;
    }

    // 데이터 변경
/*    public TbAtrdDto updateById(String id, TbAtrdDto.TbAtrdUpdReq req) {
        TbAtrd entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }*/

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
/*    public List<TbAtrdDto> mergeInfoList(List<TbAtrdDto.TbAtrdUpdReq> reqList) {
        List<TbAtrdDto> result = new ArrayList<>();
        for (TbAtrdDto.TbAtrdUpdReq req : reqList) {
            TbAtrd obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }*/

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbAtrdDto mergeInfo(String atrdId, TbAtrdDto.TbAtrdUpdReq req) {
        TbAtrd obj = req.toEntity();

        // 구성정보 삭제
        this.roadRltnService.deleteDataById(atrdId);
        // 도로정보 생성
        this.repo.save(obj);

        if (req.getRoads() != null) {
            for (TbAtrdRltnRoadDto.TbAtrdRoadRltnUpdReq rltn : req.getRoads()) {
                TbAtrdRltnRoad rltnObj = rltn.toEntity(atrdId);
                this.roadRltnService.save(rltnObj);
            }
        }
        return obj.toDto(new ArrayList<>());
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbAtrdDto deleteById(String atrdId) {
        TbAtrd entity = requireOne(atrdId);
        this.roadRltnService.deleteDataById(atrdId);
        this.repo.deleteById(atrdId);
        return entity.toDto(new ArrayList<>());
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
/*    public List<TbAtrdDto> deleteByIds(List<String> ids) {
        List<TbAtrdDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbAtrd> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }*/

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbAtrdDto findById(String atrdId) {
        TbAtrd entity = requireOne(atrdId);
        return entity.toDto(this.roadRltnService.findRoadRltnById(atrdId));
    }

    /**
     * 정보제공구간 ID 사용 여부 조회(신규 아이디 만들때 사용)
     * @param id
     * @return
     */
    @Transactional(readOnly = true)
    public UsageCountDto findUsageId(String id) {
        UsageCountDto result = UsageCountDto.builder()
                .count(0)
                .build();
        Integer data = this.repo.findUsageId(id);
        result.setCount(data);
        return result;
    }
}
